
setwd("N://Alfonso_Gomez//1 - Experimental Procedures//190724_Ad5-dV_&_VKR_MLN9708_inhibition_(rep)//CellProfAnalys")

library("tidyr")

Plate20 <- read.csv2("wt_dV_VKR_MLN_20hpi_rep_Nucleus.csv", header = T, sep = ",")

Plate20 <- as.data.frame(Plate20)


library("stringr")

add_my_numbers <- function(data){
  a <- str_split_fixed(data$Metadata_Well,"",n = 2)
  L <- as.character(a[,1])
  N <- as.numeric(a[,2])
  data <- cbind(data, "Letter_Well"=L,"Number_Well"=N)
  return(data)
}

New_plate20 <- add_my_numbers(Plate20)

New_plate20$Letter_Well <- gsub("A","1", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("B","2", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("C","3", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("D","4", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("E","5", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("F","6", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("G","7", New_plate20$Letter_Well)
New_plate20$Letter_Well <- gsub("H","8", New_plate20$Letter_Well)

New_plate20$Letter_Well <- as.numeric(New_plate20$Letter_Well)

New_plate20$Letter_Well[1700]

######
## Now its time to count the cells in each well (Por, Neg,...)
######
## First transform the columns of the signals into numbers (not characters)

as.numeric.factor <- function(x){
  as.numeric(levels(x))[x]
}

New_plate20$Intensity_MeanIntensity_pVI <- as.numeric.factor(New_plate20$Intensity_MeanIntensity_pVI)
New_plate20$Intensity_MeanIntensity_E1A <- as.numeric.factor(New_plate20$Intensity_MeanIntensity_E1A)

library("ggplot2")

ggplot()+
  geom_point(data = New_plate20,aes(x = Number_Well,y = Intensity_MeanIntensity_pVI), size=0.5)+
  xlab("well")+
  ylab("pVI intensity")

ggplot()+
  geom_point(data = New_plate20,aes(x = Number_Well,y = Intensity_MeanIntensity_E1A), size=0.5)+
  xlab("well")+
  ylab("E1A intensity")


### cALCULATE YOUR BACKGROUND FOR THE SIGNALS

back20 <- subset(New_plate20, New_plate20$Number_Well < 4 & New_plate20$Number_Well > 1)

bpVI20 <- back20[which(back20$Intensity_MeanIntensity_pVI >= 0.0127),]
bE1A20 <- back20[which(back20$Intensity_MeanIntensity_E1A >= 0.0091),]


## then proceed with the great function
output <- matrix(nrow = 60, ncol = 8)

counting20 <- function(workp){
  Li <- workp$Letter_Well[1]
  Lf <- workp$Letter_Well[dim(workp)[1]]
  Ni <- workp$Number_Well[1]
  Nf <- workp$Number_Well[dim(workp)[1]]
  for (i in Li:Lf) {
    for (k in Ni:Nf) {
      p <- subset(workp, (workp$Letter_Well == i) & (workp$Number_Well == k))
      ce <- dim(p)[1]
      pVI <- dim(p[p$Intensity_MeanIntensity_pVI >= 0.0127,])[1]
      E1A <- dim(p[p$Intensity_MeanIntensity_E1A >= 0.0091,])[1]
      PerPospVI <- (pVI/ce)*100
      PerPosE1A <- (E1A/ce)*100
      update <- c(i,i, k, ce, pVI, PerPospVI, E1A, PerPosE1A)
      output[(k)+((i-2)*12),] <- update
    }
  }
  return(output)
}


Titring20 <- counting20(New_plate20)
colnames(Titring20) <- c("Letter_Well","Letter_Well_cod", "Number_Well", "Cells_in_Well","pVIpos","PercentPospVI", "E1A","PercentE1A")
Titring20 <- as.data.frame(Titring20)


output <- matrix(nrow = 60, ncol = 10)
counting20mean <- function(workp){
  Li <- workp$Letter_Well[1]
  Lf <- workp$Letter_Well[dim(workp)[1]]
  Ni <- workp$Number_Well[1]
  Nf <- workp$Number_Well[dim(workp)[1]]
  for (i in Li:Lf) {
    for (k in Ni:Nf) {
      p <- subset(workp, (workp$Letter_Well == i) & (workp$Number_Well == k))
      ce <- dim(p)[1]
      pVI <- dim(p[p$Intensity_MeanIntensity_pVI >= 0.0127,])[1]
      E1A <- dim(p[p$Intensity_MeanIntensity_E1A >= 0.0074,])[1]
      PerPospVI <- (pVI/ce)*100
      PerPosE1A <- (E1A/ce)*100
      if (k < 7) {
        pVImean <- PerPospVI*100/28.9
        E1Amean <- PerPosE1A*100/82.3
      } else {
        if (k > 9){
          pVImean <- PerPospVI*100/18.45
          E1Amean <- PerPosE1A*100/47.23
        } else {
          pVImean <- PerPospVI*100/22.84
          E1Amean <- PerPosE1A*100/63.48
        }
      }
      update <- c(i,i, k, ce, pVI, PerPospVI, E1A, PerPosE1A, pVImean, E1Amean)
      output[(k)+((i-2)*12),] <- update
    }
  }
  return(output)
}


Titring20mean <- counting20mean(New_plate20)
colnames(Titring20mean) <- c("Letter_Well","Letter_Well_cod", "Number_Well", "Cells_in_Well","pVIpos","PercentPospVI", "E1A","PercentE1A", "relat_inf","relat_E1A")
Titring20mean <- as.data.frame(Titring20mean)

Titring20mean$Letter_Well_cod <- gsub("1","A", Titring20mean$Letter_Well_cod)
Titring20mean$Letter_Well_cod <- gsub("2","B", Titring20mean$Letter_Well_cod)
Titring20mean$Letter_Well_cod <- gsub("3","C", Titring20mean$Letter_Well_cod)
Titring20mean$Letter_Well_cod <- gsub("4","D", Titring20mean$Letter_Well_cod)
Titring20mean$Letter_Well_cod <- gsub("5","E", Titring20mean$Letter_Well_cod)
Titring20mean$Letter_Well_cod <- gsub("6","F", Titring20mean$Letter_Well_cod)
Titring20mean$Letter_Well_cod <- gsub("7","G", Titring20mean$Letter_Well_cod)
Titring20mean$Letter_Well_cod <- gsub("8","H", Titring20mean$Letter_Well_cod)

Titring20 <- counting20(New_plate20)
colnames(Titring20) <- c("Letter_Well","Letter_Well_cod", "Number_Well", "Cells_in_Well","pVIpos","PercentPospVI", "E1A","PercentE1A")
Titring20 <- as.data.frame(Titring20)

Titring20$Letter_Well_cod <- gsub("1","A", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("2","B", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("3","C", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("4","D", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("5","E", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("6","F", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("7","G", Titring20$Letter_Well_cod)
Titring20$Letter_Well_cod <- gsub("8","H", Titring20$Letter_Well_cod)

plot(c(1:60), Titring20$PercentE1A)


write.csv2(Titring20, file = "190726_wt_dV_VKR_MLN_20h_rep.csv")

write.csv2(Titring20mean, file = "190726_wt_dV_VKR_MLN_20h_mean_rep.csv")


######
######  Calculate the means now
######

output <- matrix(nrow = 20,ncol = 12)

calc_my_meansd <- function(Con,p,titr){
  Li <- titr$Letter_Well[1]
  Lf <- titr$Letter_Well[dim(titr)[1]]
  output <- matrix(nrow = (Lf-Li+1),ncol = 12)
  for (i in Li:Lf) {
    row <- i
    cells <- mean(titr$Cells_in_Well[titr$Letter_Well == i])
    sdcells <- sd(titr$Cells_in_Well[titr$Letter_Well == i])
    inf <- mean(titr$PercentPospVI[titr$Letter_Well == i])
    sd <- sd(titr$PercentPospVI[titr$Letter_Well == i])
    E1A <- mean(titr$PercentE1A[titr$Letter_Well == i])
    sdE1A <- sd(titr$PercentE1A[titr$Letter_Well == i])
    if (p == 0) {
      absolut <- mean(titr$PercentPospVI[titr$Letter_Well == i])
      absolutE1A <- mean(titr$PercentE1A[titr$Letter_Well == i])
    } else{
      absolut <- mean(titr$PercentPospVI[titr$Letter_Well == i])*100/mean(titr$PercentPospVI[titr$Letter_Well == 2])
      absolutE1A <- mean(titr$PercentE1A[titr$Letter_Well == i])*100/mean(titr$PercentE1A[titr$Letter_Well == 2])
    }
    update <- c(Con, p, row, row,cells, sdcells, inf, sd,E1A,sdE1A, absolut,absolutE1A)
    output[i-1,] <- update
  }
  return(output)
}

Mock <- subset(Titring20mean, Titring20mean$Number_Well < 4)
MeanMo <- calc_my_meansd(6, 0, Mock)
colnames(MeanMo) <- c("Condition", "Virus", "Row", "Letter","Cells","SDcells","Infpercentmean", "SD","E1APercent","SDE1A", "RelatInf","RelatE1A")

wt <- subset(Titring20mean, Titring20mean$Number_Well > 3 & Titring20mean$Number_Well < 7)
Meanwt <- calc_my_meansd(7, 1, wt)
colnames(Meanwt) <- c("Condition", "Virus", "Row", "Letter","Cells","SDcells","Infpercentmean", "SD","E1APercent","SDE1A", "RelatInf","RelatE1A")

VKR <- subset(Titring20mean, Titring20mean$Number_Well > 6 & Titring20mean$Number_Well < 10)
MeanVKR <- calc_my_meansd(8, 2, VKR)
colnames(MeanVKR) <- c("Condition", "Virus", "Row", "Letter","Cells","SDcells","Infpercentmean", "SD","E1APercent","SDE1A", "RelatInf","RelatE1A")

dV <- subset(Titring20mean, Titring20mean$Number_Well > 9)
MeandV <- calc_my_meansd(9, 3, dV)
colnames(MeandV) <- c("Condition", "Virus", "Row", "Letter","Cells","SDcells","Infpercentmean", "SD","E1APercent","SDE1A", "RelatInf","RelatE1A")




LMB_MG132_inh <- rbind(MeanMo,Meanwt,MeanVKR,MeandV)
LMB_MG132_inh <- as.data.frame(LMB_MG132_inh)

LMB_MG132_inh$Virus <- gsub("0","Mock", LMB_MG132_inh$Virus)
LMB_MG132_inh$Virus <- gsub("1","wt", LMB_MG132_inh$Virus)
LMB_MG132_inh$Virus <- gsub("2","VKR", LMB_MG132_inh$Virus)
LMB_MG132_inh$Virus <- gsub("3","dV", LMB_MG132_inh$Virus)

LMB_MG132_inh$Condition <- gsub("6","Mock", LMB_MG132_inh$Condition)
LMB_MG132_inh$Condition <- gsub("7","wt", LMB_MG132_inh$Condition)
LMB_MG132_inh$Condition <- gsub("8","VKR", LMB_MG132_inh$Condition)
LMB_MG132_inh$Condition <- gsub("9","dV", LMB_MG132_inh$Condition)

##########
#########
##########


####
#### Time to do some nice graphs
####

LMB_MG132_inh$Row <- gsub("2","NoTrt", LMB_MG132_inh$Row)
LMB_MG132_inh$Row <- gsub("3","DMSO", LMB_MG132_inh$Row)
LMB_MG132_inh$Row <- gsub("4","MLN", LMB_MG132_inh$Row)
LMB_MG132_inh$Row <- gsub("5","MLN (W)", LMB_MG132_inh$Row)
LMB_MG132_inh$Row <- gsub("6","MLN (Aft)", LMB_MG132_inh$Row)



LMB_MG132_inh$Condition <- factor(LMB_MG132_inh$Condition, levels = c("Mock","wt","VKR","dV"))
LMB_MG132_inh$Row <- factor(LMB_MG132_inh$Row, levels = c("NoTrt","DMSO","MLN","MLN (W)", "MLN (Aft)"))

ggplot(data = LMB_MG132_inh,aes(x = Row,y = Infpercentmean, fill= Condition))+
  geom_bar(stat="identity",position=position_dodge())+
  geom_errorbar(data= LMB_MG132_inh, aes(x = Row, ymin= Infpercentmean - SD, ymax= Infpercentmean + SD), width=0.1, position = position_dodge(0.9)) +
  geom_text(aes(label=round(as.numeric(LMB_MG132_inh$Infpercentmean), 2)), vjust=1.6, color="Black",
            position = position_dodge(0.9), size=3.5)+
  ylab("Absolute percentage of pVI expressing cells") +
  xlab("Row")+
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))

ggplot(data = LMB_MG132_inh,aes(x = Row,y = RelatInf, fill= Condition))+
  geom_bar(stat="identity",position=position_dodge())+
  geom_errorbar(data= LMB_MG132_inh, aes(x = Row, ymin= RelatInf - SD, ymax= RelatInf + SD), width=0.1, position = position_dodge(0.9)) +
  geom_text(aes(label=round(as.numeric(LMB_MG132_inh$RelatInf), 0)), vjust=1.6, color="Black",
            position = position_dodge(0.9), size=3.5)+
  ylab("Relative percentage of pVI expressing cells") +
  xlab("Row")+
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))


####
#### E1A
####

LMB_MG132_inh$Condition <- factor(LMB_MG132_inh$Condition, levels = c("Mock","wt","VKR","dV"))
LMB_MG132_inh$Row <- factor(LMB_MG132_inh$Row, levels = c("NoTrt","DMSO","MLN","MLN (W)", "MLN (Aft)"))

ggplot(data = LMB_MG132_inh,aes(x = Row,y = E1APercent, fill= Condition))+
  geom_bar(stat="identity",position=position_dodge())+
  geom_errorbar(data= LMB_MG132_inh, aes(x = Row, ymin= E1APercent - SDE1A, ymax= E1APercent + SDE1A), width=0.1, position = position_dodge(0.9)) +
  geom_text(aes(label=round(as.numeric(LMB_MG132_inh$E1APercent), 2)), vjust=1.6, color="Black",
            position = position_dodge(0.9), size=3.5)+
  ylab("Absolute percentage of E1A expressing cells") +
  xlab("Row")+
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))


ggplot(data = LMB_MG132_inh,aes(x = Row,y = RelatE1A, fill= Condition))+
  geom_bar(stat="identity",position=position_dodge())+
  geom_errorbar(data= LMB_MG132_inh, aes(x = Row, ymin= RelatE1A - SDE1A, ymax= RelatE1A + SDE1A), width=0.1, position = position_dodge(0.9)) +
  geom_text(aes(label=round(as.numeric(LMB_MG132_inh$RelatE1A), 0)), vjust=1.6, color="Black",
            position = position_dodge(0.9), size=3.5)+
  ylab("Relative percentage of E1A expressing cells") +
  xlab("Row")+
  theme(axis.text.x = element_text(angle = 45, size=9, hjust = 1))

round(as.numeric(LMB_MG132_inh$RelatInf), 0)

write.csv2(LMB_MG132_inh, file = "190726_wt_dV_VKR_MLN_PerInf_rep.csv")
